import java.io.*;
import java.net.*;
import java.util.*;

class CommClient extends Thread {
  protected Socket branchementAvecLeClient;
  protected BufferedReader ecouteurDuCombine;
  protected PrintStream microphoneDuCombine;
  public CommClient(Socket uneCommunicationAvecUnClient) {
    branchementAvecLeClient = uneCommunicationAvecUnClient;
    try {
      ecouteurDuCombine = new BufferedReader(new InputStreamReader(branchementAvecLeClient.getInputStream()));
      microphoneDuCombine = new PrintStream(branchementAvecLeClient.getOutputStream());
    } catch (Exception e) {
      ecouteurDuCombine = null;
      microphoneDuCombine = null;
    }
  }
  public void run() {
    String lu = "";
    try {
	  do {
        lu = ecouteurDuCombine.readLine();
		if (lu != null) {
		  System.out.println(lu);
          if (!lu.equals(".")) microphoneDuCombine.println(lu.toUpperCase());
		} else {
		  lu = "";
		}
      } while(!lu.equals("."));
      deconnecte();
    } catch (IOException e) {}
	finally {
      deconnecte();
	}
  }
  public void deconnecte() {
    try {
      System.out.println("Deconnexion d'un client");
      branchementAvecLeClient.close();
	} catch (IOException e) {}
  }
}

class ServeurEcho {
  private static PrintStream ecran = System.out;
  public static void main(String args[]) throws Exception {
    boolean onPoursuit = true;
    ServerSocket leServeur = new ServerSocket(3000);	
    do {
      Socket branchementClient = leServeur.accept();
	  ecran.println("Nouveau client.");
      CommClient cc = new CommClient(branchementClient);
	  cc.start();
    } while(onPoursuit);
    leServeur.close();
  }
}